﻿-- credits to:
-- HopeASD (NGA qfeizaijun)/ 简繁(NGA zhangzhanxian3)
local addonName, addon = ...
local _
addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
big = true,
name = true,
arrow = true,
scale =true,
texture = true,
jian = true,
ch = true,
sf = true,
pvp = true,
bufftext = true;
hp = true,
hph = false,
po = true,
mytarget = true,
namecolor = true,
killtexture = true,
auto = true,
hps = 3,
iKillper = 0,
nScale = 0.7,
dq = 1,
qt = 1,
zt = 1,
num = 0.9,
Ve = 2.7,
Ho = 1.39,
oh = 0.6,
ov = 0.8,
buffz = 25,
buffy = 0,
color = {
	["rgb0"] = {r=1, g=0, b=0}, 
    ["rgb1"] = {r=1, g=0, b=0}, 
    ["rgb2"] = {r=0.3, g=0, b=0.6},
	["rgb3"] = {r=0.2, g=0.3, b=0.6},
	["rgb4"] = {r=1, g=0.5, b=0},
	["rgb5"] = {r=0, g=1, b=1},
	["rgb6"] = {r=0, g=1, b=0},
	["rgb7"] = {r=1, g=0, b=1},
}

}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	if addon ~= "PlateColor" then return end
	if not PlateColorDB then PlateColorDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if PlateColorDB[i] == nil then PlateColorDB[i] = {} end
			for k, v in pairs(j) do
				if PlateColorDB[i][k] == nil then
					PlateColorDB[i][k] = v
				end
			end
		else
			if PlateColorDB[i] == nil then PlateColorDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()

if PlateColorDB.name ==  true  then 
--名字放大並描邊 NGA@EKE:https://bbs.nga.cn/read.php?tid=11956803
local function SetFont(obj, optSize) 
local fontName, _,fontFlags  = obj:GetFont() 
obj:SetFont(fontName,optSize,"OUTLINE") 
obj:SetShadowOffset(0, 0) 
end 
local ds = GetCurrentScaledResolution()
if ds <= 1920
then ds = 17
else
ds = 15
end

SetFont(SystemFont_LargeNamePlate,ds) 
SetFont(SystemFont_NamePlate,10) 
SetFont(SystemFont_LargeNamePlateFixed,ds) 
SetFont(SystemFont_NamePlateFixed,10) 
SetFont(SystemFont_NamePlateCastBar,ds)

end
--加载一次滑动条的cvar
SetCVar("nameplateGlobalScale", PlateColorDB.nScale)	--全局缩放
SetCVar("nameplateSelectedScale", PlateColorDB.dq)	--当前缩放
SetCVar("nameplateLargerScale", PlateColorDB.dq)	--首领缩放
SetCVar("nameplateMaxAlpha", PlateColorDB.qt)	--10码外
SetCVar("nameplateMinAlpha", PlateColorDB.qt)	--10码内
SetCVar("nameplateOccludedAlphaMult", PlateColorDB.zt)	--障碍物后透明度
SetCVar("cameraDistanceMaxZoomFactor", 2.6)	--最大视角
SetCVar("nameplateOverlapH",  PlateColorDB.oh)	--水平间距
SetCVar("nameplateOverlapV",  PlateColorDB.ov)	--垂直间距

--堆叠间距
if PlateColorDB.jian == true then
--SetCVar("nameplateMotion", 1) --姓名版堆叠


--距离缩放
SetCVar("namePlateMinScale", 1)  --default is 0.8 
SetCVar("namePlateMaxScale", 1)

SetCVar("UnitNameEnemyPlayerName",1) --敌对玩家
SetCVar("UnitNameEnemyMinionName",1) --敌对玩家仆从
SetCVar("nameplateShowEnemies",1) --敌对玩家血条
SetCVar("nameplateShowEnemyMinions",1) --敌对玩家仆从血条
SetCVar("nameplateShowEnemyMinus",1) --敌对玩家杂兵血条
SetCVar("nameplateShowAll",1) --显示所有姓名版
--姓名版帖边
SetCVar("nameplateOtherTopInset", 0.08) 
SetCVar("nameplateOtherBottomInset", 0.1) 
SetCVar("nameplateLargeTopInset", 0.08) 
SetCVar("nameplateLargeBottomInset", 0.1)


--SetCVar ("nameplateSelfTopInset", .5)	--个人资源位置默认0.5最大0.69999
end

if GetCVar("nameplateShowOnlyNames") ~= "0" then
SetCVar("nameplateShowOnlyNames", 0)	--关闭仅显示名字模式
end

--怀旧设置
SetCVar("NamePlateVerticalScale", 2.7)	--高
SetCVar("NamePlateHorizontalScale",  1.5)	--宽
hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
      for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
         local unitFrame = namePlate.UnitFrame
         unitFrame.healthBar.border:Hide()
         --unitFrame.healthBar.background:Hide()
         unitFrame.name:SetPoint("BOTTOM", unitFrame.healthBar,"TOP" ,0, 2)
		 unitFrame.healthBar:SetPoint("TOPLEFT", unitFrame, 40, -30)
		 unitFrame.healthBar:SetPoint("BOTTOMRIGHT", unitFrame, -45, 0)
         unitFrame.LevelFrame:SetPoint("RIGHT", unitFrame.healthBar, "LEFT", 0, 0)
		 unitFrame.CastBar.Border:Hide()
		 unitFrame.CastBar:SetPoint("TOPLEFT", unitFrame.healthBar, "BOTTOMLEFT", 5, -2)
      end
end)
--[[光环相关来自RSPlate
hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
local bar = NamePlateDriverFrame:GetClassNameplateBar()
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local nprot = GetCVar("nameplateResourceOnTarget")
		local npbuffy = PlateColorDB.buffz-12+PlateColorDB.buffy
		if bar and bar:IsShown() and unitFrame.name:IsShown() and nprot == "1" and UnitIsUnit(namePlate.UnitFrame.displayedUnit, "target")
		then npbuffy = npbuffy+44  elseif unitFrame.name:IsShown() then  npbuffy = npbuffy+22 end
		unitFrame.BuffFrame:SetPoint("BOTTOM", unitFrame.healthBar, "TOP", 0,npbuffy);
		if unitFrame.unit then 
			local buff = unitFrame.BuffFrame
			for i = 1, BUFF_MAX_DISPLAY do
				if buff.buffList[i] then 
					if PlateColorDB.buffz > 20 then 
						--光环大小
						buff.buffList[i]:SetSize(PlateColorDB.buffz,PlateColorDB.buffz)
						buff.buffList[i].Icon:SetPoint("TOPLEFT",buff.buffList[i],"TOPLEFT", 1, -1)
						buff.buffList[i].Icon:SetPoint("BOTTOMRIGHT",buff.buffList[i],"BOTTOMRIGHT", -1, 1)
					end
					if PlateColorDB.bufftext then
					--计时器
					buff.buffList[i].Cooldown:SetHideCountdownNumbers(false)
					--计时器大小
					local regon = buff.buffList[i].Cooldown:GetRegions()
					if regon.GetText then 
						regon:SetFont(STANDARD_TEXT_FONT,15, "OUTLINE")  --Default : 15 "OUTLINE"
					end	
					end
				end
			end
		end
	end	
end)
--]]


if PlateColorDB.texture == true then
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
	--local bars=NamePlateDriverFrame:GetClassNameplateManaBar() 
	if frame:IsForbidden() then return end
	if frame:GetName() then return end
	--if bars then bars:SetStatusBarTexture(.9,.9,.9) end
	frame.healthBar:SetStatusBarTexture(.75,.75,.75)
	--frame.castBar:SetStatusBarTexture(.75,.75,.75)
	--frame.healthBar.border:Hide()	--隐藏黑边框
	--frame.healthBar.border:SetAlpha(.4)
end)
end

--血条右侧显示箭头
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
	--if C_NamePlate.GetNamePlateForUnit(frame.unit) ~= C_NamePlate.GetNamePlateForUnit("player") and not UnitIsPlayer(frame.unit) and not CompactUnitFrame_IsTapDenied(frame) then
	if frame:IsForbidden() then return end
	if frame:GetName() then return end	
	if UnitName(frame.unit) == UnitName("Player") then return end	--防止自身
		if not frame.arrow then
			frame.arrow = frame:CreateTexture(nil, "PARENT")
			frame.arrow:SetTexture("Interface\\Addons\\PlateColor\\blue.tga")		-- 图标路径
			frame.arrow:SetPoint("LEFT", frame.healthBar, "right", -5, 0)				-- 右方箭头位置
			frame.arrow:SetSize(40, 40)										-- 箭头大小
			frame.arrow:SetAlpha(0)
		end
		if UnitIsUnit(frame.displayedUnit, "target") and PlateColorDB.arrow ==  true and UnitName(frame.unit) ~= UnitName("Player") then
			frame.arrow:SetAlpha(1)
		else
			frame.arrow:SetAlpha(0)
		end
end)
--斩杀线
local zhansha
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local width = unitFrame.healthBar:GetWidth()
		local height = unitFrame.healthBar:GetHeight()
		local fsid,_,_,_,_,_,_,_,_,fsidtf = GetTalentInfo(1,3,1)	--法师判断第一行第三个天赋
	if PlateColorDB.auto == true then
		if IsSpellKnown(281000) or IsSpellKnown(280735) or IsSpellKnown(330334) or IsSpellKnown(330325) or IsSpellKnown(343294) then
		--281000武器斩杀35,280735狂暴斩杀35,330334武器判罪35,330325狂暴判罪35,343294邪DK灵魂收割,173243奥法弹幕橙or IsEquippedItem(173243)
		zhansha = 35
		elseif fsid == 22462 and fsidtf == true then	--灼烧之触
		zhansha = 30
		elseif IsSpellKnown(24275) or IsSpellKnown(163201) or IsSpellKnown(5308) or IsSpellKnown(32379) or IsSpellKnown(53351) or IsSpellKnown(320976) or IsSpellKnown(317349) or IsSpellKnown(317485) then
		--24275愤怒之锤,163201武器防斩杀20,5308狂暴斩杀20,32379牧师灭,53351兽王射击夺命,320976生存夺命,317349武器防判罪20,317485狂暴判罪20
		zhansha = 20
		--elseif IsSpellKnown(322109) then	--轮回之触
		--zhansha = 15
		else
		zhansha = 0
		end
	else
		zhansha = PlateColorDB.iKillper
	end
		if not unitFrame.killline then
		unitFrame.killline = unitFrame.healthBar:CreateTexture(nil, "OVERLAY")
		unitFrame.killline:SetSize(2, height)	
		unitFrame.killline:SetTexture("Interface\\Buttons\\WHITE8x8")
		else
		unitFrame.killline:SetPoint("LEFT",unitFrame.healthBar,"LEFT",zhansha*width/100, 0)
		if zhansha == 0 or PlateColorDB.killtexture == false then unitFrame.killline:Hide() else unitFrame.killline:Show() end
		end
	end
end)
--血条变色
hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
   if C_NamePlate.GetNamePlateForUnit(frame.unit) ~= C_NamePlate.GetNamePlateForUnit("player") and not UnitIsPlayer(frame.unit) and not CompactUnitFrame_IsTapDenied(frame) then
	  local threat = UnitThreatSituation("player", frame.unit) or 0
	  local reaction = UnitReaction(frame.unit, "player")
	  local name = UnitName(frame.unit)
	  local me = UnitName("player")
	  local pt = UnitIsUnit(frame.unit.."target", me)
	  local Cur = UnitHealth(frame.unit)
	  local Max = UnitHealthMax(frame.unit)
	  local Per = Cur/Max*100
	  local guid = UnitGUID(frame.unit)
	  local _, _, _, _, _, id = strsplit("-", guid or "") 
	  local combat = UnitAffectingCombat(frame.unit)
	    if id == "120651" then --邪能炸药
			r, g, b = 0,1,0	--绿色
		elseif ((id == "134389") or (id == "134390") or (id == "174773")or (id == "170483")) and pt == true and PlateColorDB.ch == true then
			r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	--目标是你但是无仇恨预警
		elseif threat == 3  and PlateColorDB.ch == true then
            r, g, b = PlateColorDB.color.rgb2.r,PlateColorDB.color.rgb2.g,PlateColorDB.color.rgb2.b	-- 仇恨是你 颜色
		elseif threat == 2 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb3.r,PlateColorDB.color.rgb3.g,PlateColorDB.color.rgb3.b	--仇恨降低  颜色
        elseif threat == 1 and PlateColorDB.ch == true then      
            r, g, b = PlateColorDB.color.rgb4.r,PlateColorDB.color.rgb4.g,PlateColorDB.color.rgb4.b	-- 高仇恨  颜色
		elseif Per <=  zhansha then
			r, g, b = PlateColorDB.color.rgb7.r,PlateColorDB.color.rgb7.g,PlateColorDB.color.rgb7.b	--斩杀
		elseif UnitIsUnit(frame.displayedUnit, "target") and PlateColorDB.mytarget == true then
			r, g, b = PlateColorDB.color.rgb5.r,PlateColorDB.color.rgb5.g,PlateColorDB.color.rgb5.b	-- 你的目标 颜色
		elseif combat == true then
			r, g, b = PlateColorDB.color.rgb1.r,PlateColorDB.color.rgb1.g,PlateColorDB.color.rgb1.b	--战斗状态
		elseif reaction == 4 then
			r, g, b = 1, 1, 0		-- 中立怪 黄色
		elseif reaction >= 5 then
			r, g, b = 0, 1, 0		-- 友方npc 绿色
        else
			r, g, b = PlateColorDB.color.rgb0.r,PlateColorDB.color.rgb0.g,PlateColorDB.color.rgb0.b
        end
      frame.healthBar:SetStatusBarColor(r, g, b, 1)
   end
end) 
--名字变色(针对特殊怪)
hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
if PlateColorDB.namecolor == false then return end
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
	local unitFrame = namePlate.UnitFrame
	local _,_,_,_,_,_,_,_,_,buff1 = UnitBuff(unitFrame.unit,1)
	local _,_,_,_,_,_,_,_,_,buff2 = UnitBuff(unitFrame.unit,2)
	local _,_,_,_,_,_,_,_,_,buff3 = UnitBuff(unitFrame.unit,3)
	local _,_,_,_,_,_,_,_,_,buff4 = UnitBuff(unitFrame.unit,4)
	local guid = UnitGUID(unitFrame.unit)
	local _, _, _, _, _, id = strsplit("-", guid or "")
	if id == "174773" then
	unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
	end
	if (buff1 or buff2 or buff3 or buff4) == 343502 then
	unitFrame.name:SetTextColor(PlateColorDB.color.rgb6.r,PlateColorDB.color.rgb6.g,PlateColorDB.color.rgb6.b,1)
	end
	end
end)
--血条放大与缩小
hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local guid = UnitGUID(unitFrame.unit)
		local _, _, _, _, _, id = strsplit("-", guid or "") 
		if id == "5925" or id == "105451" or id == "105427" or id == "61245" then	--图腾
		unitFrame.healthBar:SetHeight(30)
		end
		if id == "165108" then	--仙林BOSS小怪
		unitFrame.healthBar:SetHeight(6)
		unitFrame.name:Hide()
		end

	end
end)

local ta = function(frame)
if frame:IsForbidden() then return end
if frame:GetName() then return end
if UnitName(frame.unit) == UnitName("Player") then return end	----防止自身
if frame then
local namea = UnitName(frame.unit.."target")
local myname = UnitName("Player")
local players = UnitIsPlayer(frame.unit)
local _, class = UnitClass(frame.unit.."target")
local guid = UnitGUID(frame.unit)
local _, _, _, _, _, id = strsplit("-", guid or "") 
color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
if not frame.ta then
frame.ta = frame.healthBar:CreateFontString(nil, "ARTWORK")
frame.ta:SetFont(STANDARD_TEXT_FONT, 20, 'OUTLINE')
frame.ta:SetPoint("LEFT",frame,"RIGHT",-60, 0)
frame.ta:Hide()
elseif PlateColorDB.sf == true and players == false then
frame.ta:SetText(namea) 
if ( UnitCastingInfo(frame.unit) ~= nil or UnitChannelInfo(frame.unit) ~= nil ) or id == "174773"  then	--and frame.ta:GetText() == myname then
if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
frame.ta:Show()
else
frame.ta:Hide()
end
elseif PlateColorDB.pvp == true and players == true then
if color then frame.ta:SetTextColor(color.r, color.g, color.b) end
frame.ta:SetText(namea)
if frame.ta:GetText() == myname then
frame.ta:Show()
else
frame.ta:Hide()
end
else frame.ta:Hide()
end
end
end
hooksecurefunc("CompactUnitFrame_OnUpdate", ta)

local hp = function(frame)
local iType = 3
if frame:IsForbidden() then return end
if frame:GetName() then return end
if frame then
if not frame.hp then
frame.hp = frame.healthBar:CreateFontString(nil, "ARTWORK")
frame.hp:SetFont(STANDARD_TEXT_FONT, GetCVar("NamePlateHorizontalScale")*15-7, 'OUTLINE')
else
local CurHealth = UnitHealth(frame.unit)
local MaxHealth = UnitHealthMax(frame.unit)
local fPer = string.format("%d",(CurHealth/MaxHealth*100)).."%"
local fPerr = string.format("%.1f",(CurHealth/MaxHealth*100)).."%"
local fCur = nil
if CurHealth > 10000 then
		fCur = string.format("%.1f",CurHealth/10000).."w"
	else
		fCur = tostring(CurHealth)
end
if PlateColorDB.hps == 1 then
frame.hp:SetPoint("RIGHT",0,0)
frame.hp:SetText(fCur)
elseif PlateColorDB.hps == 2 then
frame.hp:SetPoint("RIGHT",0,0)
frame.hp:SetText(fPer)
elseif PlateColorDB.hps == 3 then
frame.hp:SetPoint("RIGHT",0,0)
frame.hp:SetText(fPerr)
elseif PlateColorDB.hps == 4 then
frame.hp:SetPoint("CENTER",5,0)
frame.hp:SetText(fCur.." - "..fPer)
elseif PlateColorDB.hps == 5 then
frame.hp:SetPoint("CENTER",5,0)
frame.hp:SetText(fCur.." - "..fPerr)
end

if PlateColorDB.hp == true and UnitName(frame.unit) ~= UnitName("Player") then
frame.hp:Show()
frame.hp:SetScale(PlateColorDB.num)
else
frame.hp:Hide()
end
end
end
end
hooksecurefunc("CompactUnitFrame_OnUpdate", hp)

--[[
hooksecurefunc("CompactUnitFrame_OnUpdate", function(frame)
local bar = NamePlateDriverFrame:GetClassNameplateManaBar() 
local power = UnitPower("player")
local powermax = UnitPowerMax("player")
local dsp = GetCurrentScaledResolution()
if dsp <= 1920 then dsp = 7 else dsp = 0 end
if frame:IsForbidden() then return end
if UnitName(frame.unit) ~= UnitName("Player") then return end
if (not frame.po) and not platecolorselfpowertext and bar then
frame.po = bar:CreateFontString("platecolorselfpowertext", "ARTWORK")
frame.po:SetFont(STANDARD_TEXT_FONT, GetCVar("NamePlateHorizontalScale")*15-dsp, 'OUTLINE')
frame.po:SetPoint("CENTER",0,-1)
end
if platecolorselfpowertext then
platecolorselfpowertext:SetText(power)
if PlateColorDB.po == true and powermax < 200 and bar then
platecolorselfpowertext:Show()
platecolorselfpowertext:SetScale(0.8)
else
platecolorselfpowertext:Hide()
end
end
end)
--]]
--[[
local function BoomBall()
	local haskey = false

	for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
		local unitFrame = namePlate.UnitFrame
		local guid = UnitGUID(unitFrame.unit)
		local _, _, _, _, _, id = strsplit("-", guid or "") 
		if id == "120651" then
			haskey = true
		end
	end	

	-- 场上存在易爆球
	if haskey then 
			for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
				local unitFrame = namePlate.UnitFrame
				local guid = UnitGUID(unitFrame.unit)
				local _, _, _, _, _, id = strsplit("-", guid or "") 
				if id ~= "120651" then
					unitFrame:Hide()
				end
			end
	else
			for i, namePlate in ipairs(C_NamePlate.GetNamePlates()) do
				local unitFrame = namePlate.UnitFrame
				unitFrame:Show()
			end		

	end
end

local boomFrame = CreateFrame("Frame")
local timei = 0 
boomFrame:SetScript("OnUpdate", function (self, elasped)
	--if not SavedData["Expball"] then return end
	timei = timei + elasped
	if timei > 0.2 then
		BoomBall()
		timei = 0
	end
end)--]]

end

G:RegisterEvent("PLAYER_LOGIN",TestFunc)

local frame, button
frame = CreateFrame("Frame", "zhichiFrame", InterfaceOptionsFrame, "UIPanelDialogTemplate")
frame.Title:SetTextColor(1,1,1)
frame.Title:SetText("掏出手机支持下")
frame:SetWidth(210)
frame:SetHeight(420)
frame:SetClampedToScreen(true)
frame:SetFrameStrata("DIALOG")
frame:SetPoint("TOPLEFT",InterfaceOptionsFrame,"TOPRIGHT", -10, 0)  
frame:SetAlpha(1)
frame:Hide()
button = CreateFrame("Button", nil, frame)
button:SetSize(190, 380)
button:SetPoint("TOPLEFT",11,-30)
button:SetNormalTexture("Interface\\Addons\\PlateColor\\111.tga")


local function defa()
PlateColorDB = DefaultDB
ReloadUI()
end

local function CreateColorBlock(parent, anchorframe, x, y)
    parent.color = parent:CreateTexture(nil, "BACKGROUND")
    parent.color:SetPoint("TOPLEFT", anchorframe, "TOPLEFT", x, y)
    parent.color:SetSize(70, 15)
    parent.color:SetColorTexture(PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b)
    
    parent.btn = CreateFrame("Button", nil, parent, "GameMenuButtonTemplate");
    parent.btn:SetPoint("TOPLEFT", anchorframe, "TOPLEFT", x, y);
    parent.btn:SetSize(70, 15);
    parent.btn:SetAlpha(0)
    parent.btn:SetNormalFontObject("GameFontNormalLarge");
    parent.btn:SetHighlightFontObject("GameFontHighlightLarge");

    local onUpdate = function(restore)
        local r, g, b = ColorPickerFrame:GetColorRGB()
        parent.color:SetColorTexture(r, g, b)
        PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b = r,g,b
    end

    local onCancel = function()
        local r, g, b = ColorPicker_GetPreviousValues()
        parent.color:SetColorTexture(r, g, b)
        PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b = r,g,b
    end

    parent.btn:SetScript("OnClick", function(self, button, down)
       local r,g,b = PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b
       ColorPickerFrame.func = onUpdate
       ColorPickerFrame.previousValues = {r = r, g = g, b = b}
       ColorPickerFrame.cancelFunc = onCancel
       ColorPickerFrame:SetColorRGB(r, g, b)
       ColorPickerFrame:Show() 
    end)
--[[
    parent.btn:SetScript("OnEnter", function(self)
        GameTooltip:SetOwner(self, "ANCHOR_CURSOR ", 20, -20)
        GameTooltip:SetText(parent.name)
        GameTooltip:Show()
    end)
    parent.btn:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)]]
end
local function CreateColorFrame(name, parent)
    local f = CreateFrame("Frame", nil, parent)
    f.name = name
    f.r, f.g, f.b, f.a = unpack(PlateColorDB.color[name])
    f.Create = CreateColorBlock
    return f
end

local function CreateColorBlocks(parent, anchorFrame, x, y)
	local rgb0 = CreateColorFrame("rgb0", parent)
    rgb0:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb0:Create(anchorFrame, x, y + 34)
	
    local rgb1 = CreateColorFrame("rgb1", parent)
    rgb1:SetPoint("TOPLEFT", anchorFrame, "TOPLEFT", x, y)
    rgb1:Create(anchorFrame, x, y)
    
    local rgb2 = CreateColorFrame("rgb2", parent)
    rgb2:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb2:Create(anchorFrame, x, y - 34)
	
	local rgb3 = CreateColorFrame("rgb3", parent)
    rgb3:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb3:Create(anchorFrame, x, y - 68)
	
	local rgb4 = CreateColorFrame("rgb4", parent)
    rgb4:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb4:Create(anchorFrame, x, y - 102)
	
	local rgb5 = CreateColorFrame("rgb5", parent)
    rgb5:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb5:Create(anchorFrame, x, y - 136)
	
	local rgb6 = CreateColorFrame("rgb6", parent)
    rgb6:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb6:Create(anchorFrame, x, y - 170)
	
	local rgb7 = CreateColorFrame("rgb7", parent)
    rgb7:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb7:Create(anchorFrame, x, y - 204)

end

local frame = CreateFrame("Frame", nil, InterfaceOptionsFrame)
frame.name = addonName
frame:SetScript("OnShow", function(frame)
	
	local PlateColor = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	PlateColor:SetPoint("TOPLEFT", 16, -15)
	PlateColor:SetText("PlateColor")
	PlateColor:SetFont("fonts\\ARHei.ttf", 30, "OUTLINE")
	
	local Color = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	Color:SetPoint("TOPLEFT", 160, -30)
	Color:SetText("原始姓名版增强")
	Color:SetFont("fonts\\ARHei.ttf", 15, nil)
	
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("恢复默认并重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 442, 25)
	clear:SetScript("OnClick", function()
		defa()
	end)
	
	local zhichi = CreateFrame("Button", "AddUIzhichi", frame, "UIPanelButtonTemplate")
	zhichi:SetText("兄弟们吃不起饭了想想办法")
	zhichi:SetWidth(220)
	zhichi:SetHeight(25)
	zhichi:SetPoint("BOTTOMRIGHT", 0, 0)
	zhichi:SetScript("OnClick", function()
		 ToggleFrame(zhichiFrame);
	end)
	
	local s0 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s0:SetPoint("TOPLEFT", 460, -26)
	s0:SetText("全局颜色")
	local s1 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s1:SetPoint("TOPLEFT", 460, -60)
	s1:SetText("仇恨低")
	local s2 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s2:SetPoint("TOPLEFT", 460, -94)
	s2:SetText("仇恨是你")
	local s3 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s3:SetPoint("TOPLEFT", 460, -128)
	s3:SetText("仇恨不稳")
	local s4 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s4:SetPoint("TOPLEFT", 460, -162)
	s4:SetText("仇恨高")
	--local s5 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	--s5:SetPoint("TOPLEFT", 460, -196)
	--s5:SetText("你的目标")
	--local s6 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	--s6:SetPoint("TOPLEFT", 460, -230)
	--s6:SetText("鼓舞怪/特殊怪")
	local s7 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	s7:SetPoint("TOPLEFT", 460, -264)
	s7:SetText("斩杀")
	CreateColorBlocks(frame, frame, 380, -61)
	
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMLEFT", 40, -30)
	qqun:SetText("斗鱼:323075                   QQ群:718148969")
	qqun:SetJustifyH("RIGHT")

	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "PlateColorCheck" .. label, frame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = description
		--check.tooltipRequirement = description
		return check
	end
	
	local namec = newCheckbox("血条名字美化|cffFFC0CB(重载生效)|r","ekk的血条名字美化",function(self, value) PlateColorDB.name = value end)
	namec:SetChecked(PlateColorDB.name)
	namec:SetPoint("TOPLEFT", 16, -60)
	
	local jianc = newCheckbox("血条相关CVar|cffFFC0CB(重载生效)|r","ESC-界面-名字,自动勾选相关设置",function(self, value) PlateColorDB.jian = value end)
	jianc:SetChecked(PlateColorDB.jian)
	jianc:SetPoint("TOPLEFT", 16, -90)
	
	local texturec = newCheckbox("血条扁平材质|cffFFC0CB(重载生效)|r","扁平材质血条",function(self, value) PlateColorDB.texture = value end)
	texturec:SetChecked(PlateColorDB.texture)
	texturec:SetPoint("TOPLEFT", 16, -120)
	
	local arrowc = newCheckbox("血条右侧箭头|cffFFC0CB|r","当前目标右侧蓝色箭头",function(self, value) PlateColorDB.arrow = value end)
	arrowc:SetChecked(PlateColorDB.arrow)
	arrowc:SetPoint("TOPLEFT", 16, -150)
	
	local chc = newCheckbox("仇恨变色","右侧选颜色",function(self, value) PlateColorDB.ch = value end)
	chc:SetChecked(PlateColorDB.ch)
	chc:SetPoint("TOPLEFT", 16, -180)
	
	local sfc = newCheckbox("施法预警","对你读条血条上会显示你的名字",function(self, value) PlateColorDB.sf = value end)
	sfc:SetChecked(PlateColorDB.sf)
	sfc:SetPoint("TOPLEFT", 16, -210)
	
	local pvpc = newCheckbox("被集火预警(PvP)","敌对玩家目标是你血条上会显示你的名字",function(self, value) PlateColorDB.pvp = value end)
	pvpc:SetChecked(PlateColorDB.pvp)
	pvpc:SetPoint("TOPLEFT", 16, -240)
	
	local bufftext = newCheckbox("显示冷却文字","在血条光环上显示计时",function(self, value) PlateColorDB.bufftext = value end)
	bufftext:SetChecked(PlateColorDB.bufftext)
	bufftext:SetPoint("TOPLEFT", 16, -270)
	
	local hpc = newCheckbox("显示生命值","在血条上显示当前生命值文本",function(self, value) PlateColorDB.hp = value end)
	hpc:SetChecked(PlateColorDB.hp)
	hpc:SetPoint("TOPLEFT", 16, -330)
	
	local poc = newCheckbox("个人资源条能量值","只有能量低于200的职业才起作用,例如法力值很多没必要监控",function(self, value) PlateColorDB.po = value end)
	poc:SetChecked(PlateColorDB.po)
	poc:SetPoint("TOPLEFT", 16, -300)
	
	local mytargetc = newCheckbox("你的目标","当前目标变色",function(self, value) PlateColorDB.mytarget = value end)
	mytargetc:SetChecked(PlateColorDB.mytarget)
	mytargetc:SetPoint("TOPLEFT", 455, -192)
	
	local namecolorc = newCheckbox("名字变色","改变怨毒/鼓舞等名字颜色",function(self, value) PlateColorDB.namecolor = value end)
	namecolorc:SetChecked(PlateColorDB.namecolor)
	namecolorc:SetPoint("TOPLEFT", 455, -226)
	
	local killtexturec = newCheckbox("斩杀分割线","用竖线隔开斩杀和非斩杀血线",function(self, value) PlateColorDB.killtexture = value end)
	killtexturec:SetChecked(PlateColorDB.killtexture)
	killtexturec:SetPoint("TOPLEFT", 500, -260)
	
	local autoc = newCheckbox("自动判断斩杀线","勾选此选项下方手动斩杀线失效",function(self, value) PlateColorDB.auto = value end)
	autoc:SetChecked(PlateColorDB.auto)
	autoc:SetPoint("TOPLEFT", 380, -290)
	
	local info = {}
	local hpDropdown = CreateFrame("Frame", "hpcursor", frame, "UIDropDownMenuTemplate")
	hpDropdown:SetPoint("TOPLEFT", 0, -360)
	hpDropdown.initialize = function()
		wipe(info)
		local fonts = {1, 2, 3, 4, 5}
		local names = {"数值", "百分比100%", "百分比100.0%","同时显示100w-100%","同时显示100w-100.0%"}
		for i, font in next, fonts do
			info.text = names[i]
			info.value = font
			info.func = function(self)
				PlateColorDB.hps = self.value
				hpcursorText:SetText(self:GetText())
			end
			info.checked = font == PlateColorDB.hps
			UIDropDownMenu_AddButton(info)
		end
	end
	local xsfs
	if PlateColorDB.hps == 1 then xsfs = "数值" 
	elseif PlateColorDB.hps == 2 then xsfs = "百分比100%" 
	elseif PlateColorDB.hps == 3 then xsfs = "百分比100.0%" 
	elseif PlateColorDB.hps == 4 then xsfs = "100w-100%" 
	elseif PlateColorDB.hps == 5 then xsfs = "100w-100.0%" end
	hpcursorText:SetText(xsfs)
	
	local function newSlider(SliderName, x, y, minValue, maxValue, curValue, valueStep, lowText, highText, upText, tipText, varformat)
		local pSlider = CreateFrame("Slider", "Slider"..SliderName , frame, "OptionsSliderTemplate" );
		pSlider:SetPoint("TOPLEFT", frame, "TOPLEFT", x, y);
		pSlider:SetMinMaxValues(minValue, maxValue);
		pSlider:SetValue(curValue);
		pSlider:SetValueStep(valueStep);
		pSlider:SetObeyStepOnDrag(true);
		pSlider.textLow = _G["Slider"..SliderName.."Low"]
		pSlider.textHigh = _G["Slider"..SliderName.."High"]
		pSlider.text = _G["Slider"..SliderName.."Text"]
		pSlider.textLow:SetText(lowText)
		pSlider.textHigh:SetText(highText)
		pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")

		pSlider:SetScript("OnValueChanged", 
		function(pSlider,event,arg1) 
			pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")
		end)
		pSlider.tooltipText = tipText
		-- body
		return pSlider
	end
	
	frame.pKillper = newSlider("iKillper", 380, -340, 0, 100, 0, 1, "关", "高血线", "手动斩杀线", "设置斩杀线,0关闭染色","%d%%")
	frame.pKillper:SetValue(PlateColorDB.iKillper)
	frame.pKillper:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.iKillper = tonumber(string.format("%d",self:GetValue()))
	end)
	
	frame.num = newSlider("num", 25, -420, 0.3, 1.5, 0.9, 0.1, " ", " ", "数值字体大小", "如果开关大姓名版,需重载后再设置","%.1f")
	frame.num:SetValue(PlateColorDB.num)
	frame.num:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.num = tonumber(string.format(self:GetValue()))
	end)
	
	--[[
	frame.Ve = newSlider("Ve", 225, -420, 1, 5, 1.39, 0.1, " ", " ", "血条高度", "默认1.1推荐0.8","%.1f")
	frame.Ve:SetValue(PlateColorDB.Ve)
	frame.Ve:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.Ve = tonumber(string.format(self:GetValue()))
		SetCVar("NamePlateVerticalScale",  PlateColorDB.Ve)
	end)
	
	frame.Ho = newSlider("Ho", 425, -420, 1, 5, 2.7, 0.1, " ", " ", "血条宽度", "默认1.1推荐0.8","%.1f")
	frame.Ho:SetValue(PlateColorDB.Ho)
	frame.Ho:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.Ho = tonumber(string.format(self:GetValue()))
		SetCVar("NamePlateHorizontalScale",  PlateColorDB.Ho)
	end)
	--]]
	frame.ov = newSlider("ov", 25, -460, 0.1, 1.5, 0.8, 0.1, " ", " ", "血条垂直间距", "默认1.1推荐0.8","%.1f")
	frame.ov:SetValue(PlateColorDB.ov)
	frame.ov:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.ov = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateOverlapV",  PlateColorDB.ov)
	end)
	
	frame.oh = newSlider("oh", 225, -460, 0.1, 1.5, 0.6, 0.1, " ", " ", "血条水平间距", "默认0.8推荐0.6","%.1f")
	frame.oh:SetValue(PlateColorDB.oh)
	frame.oh:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.oh = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateOverlapH",  PlateColorDB.oh)
	end)

	frame.nScale = newSlider("nScale", 25, -500, 0.5, 2, 0.7, 0.1, " ", " ", "姓名版缩放", "设置姓名版大小","%.1f")
	frame.nScale:SetValue(PlateColorDB.nScale)
	frame.nScale:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.nScale = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateGlobalScale", PlateColorDB.nScale)
	end)
	
	frame.dq = newSlider("dq", 25, -540, 0.5, 1.5, 1, 0.1, " ", " ", "当前目标缩放", "当前目标大小","%.1f")
	frame.dq:SetValue(PlateColorDB.dq)
	frame.dq:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.dq = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateSelectedScale", PlateColorDB.dq)
		SetCVar("nameplateLargerScale", PlateColorDB.dq)
	end)
	
	frame.qt = newSlider("qt", 225, -500, 0.1, 1, 1, 0.1, " ", " ", "血条透明度", "全局透明度","%.1f")
	frame.qt:SetValue(PlateColorDB.qt)
	frame.qt:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.qt = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateMaxAlpha", PlateColorDB.qt)	--10码外
		SetCVar("nameplateMinAlpha", PlateColorDB.qt)	--10码内
	end)
	
	frame.zt = newSlider("zt", 225, -540, 0.1, 1, 1, 0.1, " ", " ", "障碍物透明度", "障碍物后的血条透明度","%.1f")
	frame.zt:SetValue(PlateColorDB.zt)
	frame.zt:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.zt = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateOccludedAlphaMult", PlateColorDB.zt)	--障碍物后透明度
	end)
	
	frame.buffz = newSlider("buffz", 425, -460, 20, 40, 20, 1, " ", " ", "血条BUFF大小", "20为暴雪默认大小","%d")
	frame.buffz:SetValue(PlateColorDB.buffz)
	frame.buffz:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.buffz = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateOccludedAlphaMult", PlateColorDB.buffz)	
	end)
	
	frame.buffy = newSlider("buffy", 425, -500, -20, 20, 0, 1, " ", " ", "血条BUFF偏移", "buff偏移,大往上,小往下","%d")
	frame.buffy:SetValue(PlateColorDB.buffy)
	frame.buffy:HookScript("OnValueChanged", function(self, value)
		PlateColorDB.buffy = tonumber(string.format(self:GetValue()))
		SetCVar("nameplateOccludedAlphaMult", PlateColorDB.buffy)	
	end)
	
	frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)
SLASH_PlateColor1 = "/pc"
SlashCmdList["PlateColor"] = function() 
    InterfaceOptionsFrame_OpenToCategory(frame)
	InterfaceOptionsFrame_OpenToCategory(frame)
end